#!/usr/bin/perl
#
# Webcluster-Client YO2LOJ
#
# (C) Hans-J. Barthen, DL5DI
#     Franz-Josef-Str. 20
#     D-56642 Kruft
#
# 07.02.2008  1.Beta-Version
# 08.02.2008  1.active version at dx.db0lj.de
# 10.02.2008  URL generation for qrz.com added
# 19.02.2008  1st release for download on the web
# 24.02.2008  automatic creation of cnt-file
# 25.02.2008  convert special characters to html-codes
# 09.03.2008  show newest records first
# 07.01.2010  show date in WCY and WWV datas to recognize entries older than a day
# 30.06.2010  typo in timestamp of WWV/WCY brought up wrong month - fixed
# 21.11.2010  (YO2LOJ) convert to use cty.dat from dxcc by Fabian Kurz, DJ1YFK, added: hint bubbles, added: colorize spots
# 21.12.2010  (YO2LOJ) added: colorize local continent DX spots
# 12.11.2011  (YO2LOJ) corrected for new QRZ database access
# 08.01.2012  (YO2LOJ) added individual defined callsign dxcc lookup
# 23.01.2012  (YO2LOJ) changed color legend layout
# 04-02-2016  (YO2LOJ) changed to sans font

$| = 1;		# flush print and write
$disabled = false;

$rev = "2016-02-04";

$continent = "EU";	#own continent for highlite

# clear content of variables
$spot[1] = ""; $spot[2] = ""; $spot[3] = ""; $spot[4] = "";
$spot[5] = ""; $spot[6] = ""; $spot[7] = ""; $spot[8] = "";
$spot[9] = ""; $spot[10] = ""; $spot[11] = ""; $spot[12] = "";
$spot[13] = ""; $spot[14] = ""; $spot[15] = ""; $spot[16] = "";
$spot[17] = ""; $spot[18] = ""; $spot[19] = ""; $spot[20] = "";
$ann[1] = ""; $ann[2] = ""; $ann[3] = "";
$wcy[1] = ""; $wcy[2] = ""; $wcy[3] = "";
$wwv[1] = ""; $wwv[2] = ""; $wwv[3] = "";

# get actual date and time to create the dxspider directory and filenames
($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=gmtime(time);
$mon++;
$yday++;
$year+=1900;

# save a copy for the timestamp in the bottom of the page
$stamp=sprintf("%2.2d:%2.2d:%2.2d UTC",$hour,$min,$sec);

# create filenames
$spotfile=sprintf("/spider/data/spots/%4.4d/%3.3d.dat",$year,$yday);
$annfile=sprintf("/spider/data/ann/%4.4d/%2.2d.dat",$year,$mon);
$wcyfile=sprintf("/spider/data/wcy/%4.4d/%2.2d.dat",$year,$mon);
$wwvfile=sprintf("/spider/data/wwv/%4.4d/%2.2d.dat",$year,$mon);
$dxccfile=sprintf("/opt/webcluster/cty.dat");
$dxccversionfile=sprintf("/opt/webcluster/cty.version");


##################### Number of spots, min, max, default ##############

    if ($ARGV[0] > 0) { # min
	$n = $ARGV[0];
	if($n > 50) {
	    $n == 50;	# max
	}
    } else {
	$n = 20;	# default
    }

###################### HTML-Header ########################

    print("Content-type: text/html\n\n");
    print("<!doctype html public \"-//w3c//dtd html 4.0 transitional//en\">");
    print("<html>");
    print("<head>");
    print("   <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">");
    print("   <meta name=\"Author\" content=\"YO2LOJ\">");
    print("   <meta name=\"GENERATOR\" content=\"webcluster.pl YO2LOJ 11/2010\">");
    print("   <META HTTP-EQUIV=\"Expires\" CONTENT=\"1800\">");
    print("   <META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">");
    print("   <META HTTP-EQUIV=\"Refresh\" CONTENT=\"30\">");
    print("   <title>DX-Cluster Timisoara - YO2LOJ</title>");
    print("   <style>");
    print("   body {font-family: arial, verdana, courier; }");
    print("   </style>");
    print("</head>");
    print("<body>");
    print("<div ALIGN=right>");
    print("<table WIDTH=\"100%\" >");
    print("<tr>");
    print("<td ALIGN=CENTER><b><font size=+2>DX-Cluster Timisoara - YO2LOJ</font></b></td>");
    print("</tr>");
    print("<tr>");

    if ($disabled eq true)
    {
    	print("<td ALIGN=CENTER><b><font size=+1 color=FF0000 >*** Web Cluster is disabled for maintainance ***</font></b></td>");
	exit;
    }

#    my $ps_cmd = "ps -A | grep dx-broadcast |";
#    open (PSINFO, $ps_cmd);
#    my $ps_resp = <PSINFO>;
#    close(PSINFO);
#    if ($ps_resp eq "") {
#	print("<td ALIGN=CENTER><b><font size=+1 color=FF0000 >*** 433.675MHz 9600 Baud FSK AX.25 spot broadcasting can be enabled on request ***</font></b></td>");
#    }
#    else {
#        print("<td ALIGN=CENTER><b><font size=+1 color=009000 >*** 433.675MHz 9600 Baud FSK AX.25 spot broadcasting is enabled ***</font></b></td>");
#    }

    print("</tr>");
    print("<tr>");
#    print("<td ALIGN=CENTER><b><font size=+2 color=FF0000 >Sorry, the cluster is down for the moment!</font></b></td>");
#    print("<td ALIGN=CENTER><b><font size=+2 color=FF0000 >The cluster allows local posting only!</font></b></td>");
    print("<td ALIGN=CENTER><font size=-1 color=009000 >The cluster is up and running full featured...</font></td>");
    print("</tr>");
    print("</table></div>");

    print("<table BORDER WIDTH=\"100\%\" >");


######################################################################
#
# Create dynamic tables / be careful with changes here!
#
######################################################################


#################### DX-Spots ##########################

if(open(SPOTS, $spotfile)) {

&read_cty();

    while($line = <SPOTS>) {
	chop($line);
	
	for($i = $n;$i > 1; $i--) {
	    $spot[$i] = $spot[$i-1];
	}
	$spot[1] = $line;
    }

    $i = 1;

# Table start
    print("<table BORDER CELLSPACING=0 CELLPADDING=0 WIDTH=100% BGCOLOR=#33CCFF >");

    print("<tr bgcolor=#3399FF>");
    printf("<td>Spotter</td>");
    printf("<td>Frequency</td>");
    printf("<td>Call</td>");
    printf("<td>Comment</td>");
    printf("<td>DXCC</td>");
    printf("<td>ITU</td>");
    printf("<td>CQ</td>");
    printf("<td>Time</td>");
    print("</tr>");


    while($i <= $n) {
	($qrg,$call,$zeit,$text,$spotter,$dxccid,$dummy,$dummy,$itu,$cq,$dummy) = split(/\^/,$spot[$i],11);

	# fix some special chars which may destroy the table structure
	$text =~ s/\;/:/g;
	$text =~ s|\\|\/|g;
	$text =~ s/\&/&amp;/g;
	$text =~ s/\$/&sect;/g;
	$text =~ s/\|/&brvbar;/g;
	$text =~ s/</&lt;/g;
	$text =~ s/>/&gt;/g;
	$text =~ s/\"/&quot;/g;
	$text =~ s//&auml;/g;
	$text =~ s//&ouml;/g;
	$text =~ s//&uuml;/g;

	if((length($spotter) > 0)) {

	    if(index($call,'/') > 0){
		($teil1,$teil2) = split(/\//,$call,2);
		if(length($teil2) < length($teil1)) {
		    $qrzcall = $teil1;
		} else {
		    ($qrzcall,$dummy) = split(/\//,$teil2,2);
		}
		$dxcall = $teil1;
	    } else {
		$qrzcall = $call;
		$dxcall = $call;
	    }

	    $tmp = $qrzcall;
	    $num = $tmp =~ tr/0-9//;
	    $tmp = $qrzcall;
	    $abc = $tmp =~ tr/A-Za-z//;

	    my @spot = &dxcc($spotter);
	    my @dxcc = &dxcc($dxcall);

	    # now colorize spots
	    if($spotter eq $qrzcall)		# self spot
	    {
		print("<tr bgcolor=#CCCCCC>");
	    }
	    elsif (($dxcc[3] eq $continent) || ($spot[3] eq $continent))	# own continent spots
	    {
		if ($spot[3] eq $dxcc[3])	#local spot in own continent
		{
		    print("<tr bgcolor=#FFFFAA>");
		}
		else				#dx spot in own continent
		{
		    print("<tr bgcolor=#FFDD33>");
		}
	    }
	    elsif($spot[3] eq $dxcc[3])		# local on other continents
	    {
		print("<tr bgcolor=#AAFFFF>");
	    }
	    else				# dx on other continents
	    {
		print("<tr bgcolor=#33DDFF>");
	    }
	    printf("<td><div title=\"%s, %s\">DX de %s:</div></td>", $spot[0], $spot[3], $spotter);
	    printf("<td>%10.1f</td>",$qrg);

	    if((index($qrzcall,'/') > 0) || ($num == 0) || ($abc < 2)) {
		printf("<td>%15.15s</td>",$call);
	    } else {
		printf("<td><a href=\"http://www.qrz.com/db/%s\" target=\"QRZ.com\">%15.15s</a></td>",$qrzcall,$call);
	    }

	    printf("<td>%30.30s&nbsp;</td>",$text);

	    printf("<td><div title=\"Lat: %s Lon: %s\">(%s) %s, %s</td></div>", $dxcc[4], $dxcc[5], $dxcc[7], $dxcc[0], $dxcc[3]);
	    printf("<td>%2.2s</td>",$itu);
	    printf("<td>%2.2s</td>",$cq);
	    ($sec,$min,$std,$mtag,$jahr,$wtag,$jtag,$somzeit) = gmtime($zeit);
	    printf("<td><div title=\"%s time zone: %s\">%2.2d%2.2dZ</div></td>", $dxcc[7], $dxcc[6], $std, $min);
	    print("</tr>");
	}
	$i++;
    }

    close(SPOTS);

    print("</table>"); # Table end

    print("<table BORDER CELLSPACING=0 CELLPADDING=0 WIDTH=100% BGCOLOR=#33CCFF >");
    print("<tr bgcolor=#DDDDDD>");
    printf("<td>Color coding: </td>");
    printf("<td bgcolor=#FFDD33 width=15%>&nbsp; %s DX spots</td>", $continent);
    printf("<td width=20>&nbsp;</td><td bgcolor=#FFFFAA width=15%>&nbsp; %s local spots</td>", $continent);
    printf("<td width=20>&nbsp;</td><td bgcolor=#33DDFF width=15%>&nbsp; DX spots outside %s</td>", $continent);
    printf("<td width=20>&nbsp;</td><td bgcolor=#AAFFFF width=15%>&nbsp; Local spots outside %s</td>", $continent);
    printf("<td width=20>&nbsp;</td><td bgcolor=#CCCCCC width=15%>&nbsp; Self spots</td>");
    printf("<td width=20>&nbsp;</td>");
    print("</tr>");
    print("</table>");

}

#################### WCY-Datas ##########################

if(open(WCYS, $wcyfile)) {


    while($line = <WCYS>) {
	chop($line);
	$wcy[3] = $wcy[2];
	$wcy[2] = $wcy[1];
	$wcy[1] = $line;
    }
    $i = 1;

# Table start

    print("<table BORDER CELLSPACING=0 CELLPA[M 3DDING=0 WIDTH=\"100%\" BGCOLOR=\"#FFFF00\" >");

    while($i <= 3) {

	($zeit,$sfi,$a,$k,$expk,$r,$sa,$gmf,$aurora,$spotter,$dummy) = split(/\^/,$wcy[$i],11);
	if($sa eq "qui") {
	    $sa = "quiet";
	} elsif ($sa eq "act") {
	    $sa = "active";
	}
	
	if($gmf eq "qui") {
	    $gmf = "quiet";
	} elsif ($gmf eq "act") {
	    $gmf = "active";
	}
	($sec,$min,$std,$mtag,$monat,$jahr,$wtag,$jtag,$somzeit) = gmtime($zeit);

	if((length($spotter) > 0)) {
	    print("<tr>");
	    printf("<td>WCY de %s</td>",$spotter);
	    printf("<td>%4.4d/%2.2d/%2.2d %2.2d%2.2dZ</td>",$jahr+1900,$monat+1,$mtag,$std,$min);
	    printf("<td>SFI=%d</td>",$sfi);
	    printf("<td>A=%d</td>",$a);
	    printf("<td>K=%d</td>",$k);
	    printf("<td>expK=%1d</td>",$expk);
	    printf("<td>R=%d</td>",$r);
	    printf("<td>SA: %s</td>",$sa);
	    printf("<td>GMF: %s</td>",$gmf);
	    if($aurora eq "yes") {
		printf("<td>Aurora: <b>!YES!</b></td>");
	    } else {	    
	        printf("<td>Aurora: %s</td>",$aurora);
	    }
	    print("</tr>");
	}
	$i++;
    }    
    
    close(WCYS);

# Table end

    print("</table>");
}


#################### WWV-Datas ##########################

if(open(WWVS, $wwvfile)) {


    while($line = <WWVS>) {
	chop($line);
	$wwv[3] = $wwv[2];
	$wwv[2] = $wwv[1];
	$wwv[1] = $line;
    }
    $i = 1;

# Table start

    print("<table BORDER CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%\" BGCOLOR=\"#FF9900\" >");

    while($i <= 3) {
#	print "$wwv[$i]\n";
	($spotter,$zeit,$sfi,$a,$k,$text,$dummy) = split(/\^/,$wwv[$i],7);
	($sec,$min,$std,$mtag,$monat,$jahr,$wtag,$jtag,$somzeit) = gmtime($zeit);

	if((length($spotter) > 0)) {
	    print("<tr>");
	    printf("<td>WWV de %s</td>",$spotter);
	    printf("<td>%4.4d/%2.2d/%2.2d %2.2d%2.2dZ</td>",$jahr+1900,$monat+1,$mtag,$std,$min);
	    printf("<td>SFI=%d</td>",$sfi);
	    printf("<td>A=%d</td>",$a);
	    printf("<td>K=%d</td>",$k);
	    $text =~ tr/<>/ /;
	    printf("<td>%s</td>",$text);
	    print("</tr>");
	}
	$i++;

    }    
    
    close(WWVS);

# Table end

    print("</table>");
}


#################### Announcements ##########################

if(open(ANNS, $annfile)) {

# Table start

    print("<table BORDER CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%\" BGCOLOR=\"#33CC33\" >");

    while($line = <ANNS>) {
	chop($line);
	$ann[3] = $ann[2];
	$ann[2] = $ann[1];
	$ann[1] = $line;
    }
    $i = 1;
    while($i <= 3) {

	#($zeit,$flag,$dest,$spotter,$text,$dummy) = split(/\^/,$ann[$i],6);
	($zeit,$spotter,$dest,$text) = split(/\^/,$ann[$i],4);
	($sec,$min,$std,$mtag,$monat,$jahr,$wtag,$jtag,$somzeit) = gmtime($zeit);
	$monat++;
	#$jtag++;
	$jahr+=1900;
	if((length($spotter) > 0)) {
	    print("<tr>");
	    printf("<td>To %s de %s</td>",$dest,$spotter);
	    printf("<td>%4.4d.%2.2d.%2.2d-%2.2d%2.2dZ</td>", $jahr,$monat,$mtag,$std,$min);
	    $text =~ tr/<>/ /;
	    printf("<td>%s</td>",$text);
	    print("</tr>");
	}
	$i++;
    }
    
    close(ANNS);

# Table end

    print("</table>");
}

###################### HTML-Footer ################################
#
# Place some URLs or other information here.
# The update interval, the timestamp of the last update ($stamp) 
#
print("<table BORDER CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%\" BGCOLOR=\"#DDDDDD\" >");
print("<tr><td>");
print("CTY file last updated on ".read_cty_version()." from <a href=\"http://www.country-files.com\" target=\"_top\">www.country-files.com</a>");
print("</td></tr></table></div>");
print("<table WIDTH=\"100%\" >");
print("<tr>");
print"<td ALIGN=left><i><a href=\"http://www.yo2loj.ro\" target=\"_top\">www.yo2loj.ro</a></i></td>";
print"<td ALIGN=center>$stamp (refresh after 30s)</td>";
print"<td ALIGN=center><i><font size=-1>DX-spider link by <a href=\"http://www.pi4cc.nl\" target=\"_top\">PI4CC</a></font></td>";
print"<td ALIGN=right><i><font size=-1>Web interface by YO2LOJ (based on <a href=\"http://download.prgm.org/dl5di-soft/dxspider-webcluster/\" target=\"_top\">webcluster by DL5DI</a> and <a href=\"http://fkurz.net/ham/dxcc.html\" target=\"_top\">dxcc by DJ1YFK</a>), $rev</font></i></td>";
print("</tr>");
print("</table>");
print("</body>");
print"</html>";

sub read_cty_version {
    open CTYVER, $dxccversionfile;
    my $line = <CTYVER>;
    close CTYVER;
    return $line;
}

sub read_cty {
	# Read cty.dat from AD1C, or this program itself (contains cty.dat)
	my $self=0;

	open CTY, $dxccfile;

	while (my $line = <CTY>) {
		if (substr($line, 0, 1) ne ' ') {			# New DXCC
			$line =~ /\s+([*A-Za-z0-9\/]+):\s+$/;
			$mainprefix = $1;
			$line =~ s/\s{2,}//g;
			@{$dxcc{$mainprefix}} = split(/:/, $line);
		}
		else {							# prefix-line
			$line =~ s/\s+//g;
			unless (defined($prefixes{$mainprefix}[0])) {
				@{$prefixes{$mainprefix}} = split(/,|;/, $line);
			}
			else {
				push(@{$prefixes{$mainprefix}}, split(/,|;/, $line));
			}
		}
	}
	close CTY;

} # read_cty


###############################################################################
#
# &wpx derives the Prefix following WPX rules from a call. These can be found
# at: http://www.cq-amateur-radio.com/wpxrules.html
#  e.g. DJ1YFK/TF3  can be counted as both DJ1 or TF3, but this sub does 
# not ask for that, always TF3 (= the attached prefix) is returned. If that is 
# not want the OP wanted, it can still be modified manually.
#
###############################################################################
 
sub wpx {
  my ($prefix,$a,$b,$c);
  
  # First check if the call is in the proper format, A/B/C where A and C
  # are optional (prefix of guest country and P, MM, AM etc) and B is the
  # callsign. Only letters, figures and "/" is accepted, no further check if the
  # callsign "makes sense".
  # 23.Apr.06: Added another "/X" to the regex, for calls like RV0AL/0/P
  # as used by RDA-DXpeditions....
    
if ($_[0] =~ 
	/^((\d|[A-Z])+\/)?((\d|[A-Z]){3,})(\/(\d|[A-Z])+)?(\/(\d|[A-Z])+)?$/) {
   
    # Now $1 holds A (incl /), $3 holds the callsign B and $5 has C
    # We save them to $a, $b and $c respectively to ensure they won't get 
    # lost in further Regex evaluations.
   
    ($a, $b, $c) = ($1, $3, $5);
    if ($a) { chop $a };            # Remove the / at the end 
    if ($c) { $c = substr($c,1,)};  # Remove the / at the beginning
    
    # In some cases when there is no part A but B and C, and C is longer than 2
    # letters, it happens that $a and $b get the values that $b and $c should
    # have. This often happens with liddish callsign-additions like /QRP and
    # /LGT, but also with calls like DJ1YFK/KP5. ~/.yfklog has a line called    
    # "lidadditions", which has QRP and LGT as defaults. This sorts out half of
    # the problem, but not calls like DJ1YFK/KH5. This is tested in a second
    # try: $a looks like a call (.\d[A-Z]) and $b doesn't (.\d), they are
    # swapped. This still does not properly handle calls like DJ1YFK/KH7K where
    # only the OP's experience says that it's DJ1YFK on KH7K.

if (!$c && $a && $b) {                  # $a and $b exist, no $c
        if ($b =~ /$lidadditions/) {    # check if $b is a lid-addition
            $b = $a; $a = undef;        # $a goes to $b, delete lid-add
        }
        elsif (($a =~ /\d[A-Z]+$/) && ($b =~ /\d$/)) {   # check for call in $a
        }
}    

	# *** Added later ***  The check didn't make sure that the callsign
	# contains a letter. there are letter-only callsigns like RAEM, but not
	# figure-only calls. 

	if ($b =~ /^[0-9]+$/) {			# Callsign only consists of numbers. Bad!
			return undef;			# exit, undef
	}

    # Depending on these values we have to determine the prefix.
    # Following cases are possible:
    #
    # 1.    $a and $c undef --> only callsign, subcases
    # 1.1   $b contains a number -> everything from start to number
    # 1.2   $b contains no number -> first two letters plus 0 
    # 2.    $a undef, subcases:
    # 2.1   $c is only a number -> $a with changed number
    # 2.2   $c is /P,/M,/MM,/AM -> 1. 
    # 2.3   $c is something else and will be interpreted as a Prefix
    # 3.    $a is defined, will be taken as PFX, regardless of $c 

    if ((not defined $a) && (not defined $c)) {  # Case 1
            if ($b =~ /\d/) {                    # Case 1.1, contains number
                $b =~ /(.+\d)[A-Z]*/;            # Prefix is all but the last
                $prefix = $1;                    # Letters
            }
            else {                               # Case 1.2, no number 
                $prefix = substr($b,0,2) . "0";  # first two + 0
            }
    }        
    elsif ((not defined $a) && (defined $c)) {   # Case 2, CALL/X
           if ($c =~ /^(\d)$/) {              # Case 2.1, number
                $b =~ /(.+\d)[A-Z]*/;            # regular Prefix in $1
                # Here we need to find out how many digits there are in the
                # prefix, because for example A45XR/0 is A40. If there are 2
                # numbers, the first is not deleted. If course in exotic cases
                # like N66A/7 -> N7 this brings the wrong result of N67, but I
                # think that's rather irrelevant cos such calls rarely appear
                # and if they do, it's very unlikely for them to have a number
                # attached.   You can still edit it by hand anyway..  
                if ($1 =~ /^([A-Z]\d)\d$/) {        # e.g. A45   $c = 0
                                $prefix = $1 . $c;  # ->   A40
                }
                else {                         # Otherwise cut all numbers
                $1 =~ /(.*[A-Z])\d+/;          # Prefix w/o number in $1
                $prefix = $1 . $c;}            # Add attached number    
            } 
            elsif ($c =~ /$csadditions/) {
                $b =~ /(.+\d)[A-Z]*/;       # Known attachment -> like Case 1.1
                $prefix = $1;
            }
            elsif ($c =~ /^\d\d+$/) {		# more than 2 numbers -> ignore
                $b =~ /(.+\d)[A-Z]*/;       # see above
                $prefix = $1;
			}
			else {                          # Must be a Prefix!
                    if ($c =~ /\d$/) {      # ends in number -> good prefix
                            $prefix = $c;
                    }
                    else {                  # Add Zero at the end
                            $prefix = $c . "0";
                    }
            }
    }
    elsif (defined $a) {                    # $a contains the prefix we want
            if ($a =~ /\d$/) {              # ends in number -> good prefix
                    $prefix = $a
            }
            else {                          # add zero if no number
                    $prefix = $a . "0";
            }
    }

# In very rare cases (right now I can only think of KH5K and KH7K and FRxG/T
# etc), the prefix is wrong, for example KH5K/DJ1YFK would be KH5K0. In this
# case, the superfluous part will be cropped. Since this, however, changes the
# DXCC of the prefix, this will NOT happen when invoked from with an
# extra parameter $_[1]; this will happen when invoking it from &dxcc.
    
if (($prefix =~ /(\w+\d)[A-Z]+\d/) && (not defined $_[1])) {
        $prefix = $1;                
}
    
return $prefix;
}
else { return ''; }    # no proper callsign received.
} # wpx ends here


##############################################################################
#
# &dxcc determines the DXCC country of a given callsign using the cty.dat file
# provided by K1EA at http://www.k1ea.com/cty/cty.dat .
# An example entry of the file looks like this:
#
# Portugal:                 14:  37:  EU:   38.70:     9.20:     0.0:  CT:
#     CQ,CR,CR5A,CR5EBD,CR6EDX,CR7A,CR8A,CR8BWW,CS,CS98,CT,CT98;
#
# The first line contains the name of the country, WAZ, ITU zones, continent, 
# latitude, longitude, UTC difference and main Prefix, the second line contains 
# possible Prefixes and/or whole callsigns that fit for the country, sometimes 
# followed by zones in brackets (WAZ in (), ITU in []).
#
# This sub checks the callsign against this list and the DXCC in which 
# the best match (most matching characters) appear. This is needed because for 
# example the CTY file specifies only "D" for Germany, "D4" for Cape Verde.
# Also some "unusual" callsigns which appear to be in wrong DXCCs will be 
# assigned properly this way, for example Antarctic-Callsigns.
# 
# Then the callsign (or what appears to be the part determining the DXCC if
# there is a "/" in the callsign) will be checked against the list of prefixes
# and the best matching one will be taken as DXCC.
#
# The return-value will be an array ("Country Name", "WAZ", "ITU", "Continent",
# "latitude", "longitude", "UTC difference", "DXCC").   
#
###############################################################################

sub dxcc {
	my $testcall = shift;
	my $test = '='.$testcall;
	
	my @mydxcc = &dxcc_step($test);		# first try for special individual calls
	if ($mydxcc[0] eq "Unknown") {		# if not found, do generic dxcc search
	    @mydxcc = &dxcc_step($testcall);
	}
	return @mydxcc;
}

sub dxcc_step {
	my $testcall = shift;
	my $matchchars=0;
	my $matchprefix='';
	my $test;
	my $zones = '';                 # annoying zone exceptions
	my $goodzone;
	my $letter='';


if ($testcall =~ /\w\/\w/) {             # check if the callsign has a "/"
    $testcall = &wpx($testcall,1)."AA";		# use the wpx prefix instead, which may
                                         # intentionally be wrong, see &wpx!
}

$letter = substr($testcall, 0,1);

foreach $mainprefix (keys %prefixes) {

	foreach $test (@{$prefixes{$mainprefix}}) {
		my $len = length($test);

		if ($letter ne substr($test,0,1)) {			# gains 20% speed
			next;
		}

		$zones = '';
		

		if (($len > 5) && ((index($test, '(') > -1)			# extra zones
						|| (index($test, '[') > -1))) {
				$test =~ /^([A-Z0-9\/]+)([\[\(].+)/;
				$zones .= $2 if defined $2;
				$len = length($1);
		}
		
		if (index($testcall, '=') > -1)
		{
			if ((index($test, $testcall) > -1) && ($len == length($testcall))) {
				$matchchars = $len;
				$matchprefix = $mainprefix;
				$goodzone = $zones;
			}
		}
		else {
			if ((substr($testcall, 0, $len) eq substr($test,0,$len)) &&
									($matchchars <= $len))	{
				$matchchars = $len;
				$matchprefix = $mainprefix;
				$goodzone = $zones;
			}
		}
	}
}

my @mydxcc;										# save typing work

if (defined($dxcc{$matchprefix})) {
	@mydxcc = @{$dxcc{$matchprefix}};
}
else {
	@mydxcc = qw/Unknown 0 0 0 0 0 0 ?/;
}

# Different zones?

if ($goodzone) {
	if ($goodzone =~ /\((\d+)\)/) {				# CQ-Zone in ()
		$mydxcc[1] = $1;
	}
	if ($goodzone =~ /\[(\d+)\]/) {				# ITU-Zone in []
		$mydxcc[2] = $1;
	}
}

# cty.dat has special entries for WAE countries which are not separate DXCC
# countries. Those start with a "*", for example *TA1. Those have to be changed
# to the proper DXCC. Since there are opnly a few of them, it is hardcoded in
# here.

if ($mydxcc[7] =~ /^\*/) {							# WAE country!
	if ($mydxcc[7] eq '*TA1') { $mydxcc[7] = "TA" }		# Turkey
	if ($mydxcc[7] eq '*4U1V') { $mydxcc[7] = "OE" }	# 4U1VIC is in OE..
	if ($mydxcc[7] eq '*GM/s') { $mydxcc[7] = "GM" }	# Shetlands
	if ($mydxcc[7] eq '*IG9') { $mydxcc[7] = "I" }		# African Italy
	if ($mydxcc[7] eq '*IT9') { $mydxcc[7] = "I" }		# Sicily
	if ($mydxcc[7] eq '*JW/b') { $mydxcc[7] = "JW" }	# Bear Island

}

# CTY.dat uses "/" in some DXCC names, but I prefer to remove them, for example
# VP8/s ==> VP8s etc.

$mydxcc[7] =~ s/\///g;

return @mydxcc; 

} # dxcc ends here 

exit;

